<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<link REL="stylesheet" HREF="styles.css">
<title>ALP Settings</title>
</head>

<body topmargin="0" leftmargin="0">
<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
  <tr>
    <td bgcolor="#D0D0C0" width="150" valign="top" align="left"><img border="0" src="ALP-logo.gif"></td>
    <td width="100%" BACKGROUND="top-header.gif" valign="bottom" align="right" class="bigFont" style="border-bottom: 1 solid rgb(0,0,0); background-repeat: no-repeat; background-position: right;"><i>
    Overview for developers
    </i></td>
  </tr>
  <tr>
    <td width="150" valign="top" align="center" height="100%" bgcolor="#D0D0C0">
    <!-- #include file="menu-main.htm" -->
    </td>
    <td width="100%" valign="top" height="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="4">
      <tr>
        <td width="100%" valign="top">
          <H4>Why Active Local Pages?</H4>
<P>Perhaps the first impression anyone will get is that ALP is just a way to run
some existing ASP applications in non-typical environment, may be adapt them for
CD-ROM distribution and so on. However ALP goes much further and even if you are
not a WEB programmer you may find it more convenient than a typical form based
RAD (Rapid Application Development) environment (such as VB and Delphi). While
the desktop programming RAD environments are specialized in the desktop
applications development and on the other side Active Server Pages or CGI are
strictly WEB oriented technologies - ALP combines the traits of the both
naturally leading the developer to solutions that are capable of working on both
stand-alone machines and WEB servers supporting ASP (not only IIS).
          </P>
<P>The major programming interface for ALP are the ASP compatible pages. Besides
ASP compatible pages&nbsp; ALP supports also other WEB programming interfaces
from which CGI (Common Gateway Interface) is the most important one - it opens
the opportunity to run under ALP PHP, Perl, EXE and other CGI
scripts/applications or integrate them with ASP based applications.
          </P>
<P><b>Is it easy to use it then? </b>A WEB developer will find ALP familiar.
There are the usual virtual sites, ASP applications and directory settings, they
are simply in another place - the computer's file system. ALP integrates with
Windows Explorer and the developers just need to right click in a folder to
access the ALP settings which define how the folder will behave when viewed
through ALP. A non-WEB developer will notice that in ALP they do not design
forms with events. This may scare some people, but in fact the WEB programming way is
easier - the developer designs a prototype page, then puts some code that alters
its appearance as whole. Compared to the typical form based RAD programming this
is much simpler - instead of putting infinite lines of code in each event
handler in order to update other form elements, the page is re-created each time
something substantial changes.
          </P>
<P><b>How ALP is used in the real world?</b> It can be used in various ways - the applications can use
the standard Microsoft Internet Explorer or the included ALPFrame browser (in
which this page is viewed) which offers them additional features: dynamic menus
(see the menu of this window), dynamic control over the window appearance,
additional security features the developer can use to protect the users from
problems. The full-scale usage of ALP can be illustrated by the scheme below.
When the standard Internet Explorer is used the scheme is almost the same, but
without the ALPFrame supplied services for DHTML pages. The elements in blue are
part of ALP and are always available with it.
          </P>
<P><img border="0" src="ALPScheme.GIF">
          </P>
<P>One of the interesting elements in ALP is its <b>run-time library</b>. It is
not anything else but a set of COM components the applications can use. They are part of ALP and the developer can count on them
without need to be concerned about their availability and version. This library
is accessible the usual way - through Server.CreateObject which may look a bit
strange decision, but there is a reason. The run-time library DLL files can be
put on a WEB server machine and used from classic ASP applications running in IIS just
the same way as they are used in ALP. If we have decided otherwise (for example
to add them to the ASP object model) many developers would have been tempted to
create ALP specific code with the only advantage of a few less lines of code. Thus the way it is - every feature of the library is accessible and still
the developer is required to use common techniques that will naturally lead to
code that can be executed not only with ALP but also with IIS and even other ASP
servers.
          </P>
<P><b>Why this run-time library?</b> If you have ASP skills you are probably
familiar with FSO (FileSystemObject), ADO and other popular components. Why not
using them? No problem using whatever components you find convenient, ALP
run-time library just offers alternative and advanced features in areas not
accessible for ASP applications before (such as threads for instance). While ADO
and FSO come in various versions, sometimes are not available, the ALP run-time
library is always with your application distribution and if you choose to use it
instead of other external components there will be no need to carry with your
application tens of megabytes of redistributable files. Thus the run-time
library gives a vital opportunity to those developers who want to build
applications for the public, while the developers who use ALP to build
applications that will integrate in their organization's infrastructure can
still use the usual components and other external components that may be needed.
          </P>
<P><b>Where it will work?</b> ALP supports Windows 95/NT4 and above with
Internet Explorer 4.0 or later installed. If your application uses the ALP
run-time library it will work on all these platforms. If you use external
components - their OS compatibility will define the application requirements.
          </P>
<P><b>How to distribute and deploy the applications you are building?</b> With
ALP you receive a small installer utility which can be programmed to install
ALP, your application and additional components and resources it will need. As
ALP is compatible with Windows 95/NT4 and later the installer obeys the same
rules and is not dependent on any external software (such as Windows Installer).
Thus the installer will work even on very old OS-es where other setup solutions
will ask the user to download additional software. The installer is programmed
through a setup.cfg text file which is described in details in the ALP
documentation. It supports features like: COM DLL installation and registration
with version checking, files installation with optional time-stamp checking,
shortcuts creation, registry updates, custom install directory selected by the
user, full localization or customization of the texts shown in it, files zone-id
update (XP SP2 introduced feature) and many more.
          </P>
<P><b>What about autorun CD-ROM and other medias?</b>&nbsp; ALP applications may
run directly from a CD or from a downloaded archive without installation. Of
course you can start an installation if a CD is plugged-in, but the actual
meaning of the autorun term is more complex. It means that the application can
load and run properly without registering its components in the system registry
or installing other permanent content on the user's machine. Obviously this is a
tricky task - the application will be perfect autorun if it needs no system
update no matter where it will be started. ALPFrame viewer supports certain
features that create something that can be called a virtual COM environment. It
is created in the ALPFrame process only and the components that support the
required features can function in such an environment on-the-fly without
registration in the system registry. Of course, all the ALP components and
run-time library support these features and if the application is based on them
only - there is nothing to prevent it from running in a pure autorun mode (e.g.
the user just plugs in a CD or downloads an archive, unpacks it and starts the
ALPFrame browser's exe file). However the external components from other vendors may not always be
capable of running in virtual COM environments and the developer must carefully
consider what components will be used so that the application would be able to
work on all the targeted platforms without need of system updates. There is no
general rule about this - it depends on what the application does, how important
is it for the users and so on. The developer must consider the implied
limitations or technologies used to find the best way - installation, autorun or
something in the middle.
          </P>
<P><b>Are there other benefits from&nbsp; autorun distributions?</b>&nbsp; Yes!
While most people associate the term autorun with a CD that starts the
application when plugged in, the ability of an application to run without
need of installation gives other very interesting opportunities. For instance an
ALP application designed to run in autorun mode will be able to start even in a
guest account without permissions to write in the system registry and
directories. In such an
account (on NT/2k/XP/2k3 systems) applications that need installation will fail
and only the administrator will be able to install them, but ALP autorun
application will work properly. There are many situations in which it is better
to give the user something that can be used and then deleted leaving no waste
files or registry settings after the usage, or situations in which the
application is used to manage some data and then you want to get the application
and its data with you - this can be done with ALP in autorun mode. For
example you can put an application on a <b> flash drive</b> or <b> memory card</b> and use it on
different machines - all the changes to the data made in the databases/files on
the card will remain there, the very application will be there too and will be
used from there without need to move/install it on the local hard drive.&nbsp;
          </P>
          <P>As a conclusion it can be said that with ALP you can achieve
          portability, usage convenience and complex functionality with less
          efforts than a RAD environment will require. You are free to choose
          what components you will use to perform your work, you can integrate
          ALP applications with corporate software or create stand-alone ones.
          ALP offers huge component set in its run-time library that covers
          almost everything you may need. When you aim to maximum compatibility
          and portability you prefer the ALP Run-time library at the price of a little additional
          learning, that will pay back by minimizing the support and porting
          efforts. When you aim at integration with other applications in your
          organization's infrastructure you can use their components to
          integrate the ALP application with them. All the choices are possible.
          </P>


        </td>
      </tr>
    </table>
    </td>
  </tr>
  <!-- #include file="footer.htm" -->
</table>


</body>

</html>
