<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<link REL="stylesheet" HREF="styles.css">
<title>ALP Settings</title>
</head>

<body topmargin="0" leftmargin="0">
<table border="0" width="100%" cellspacing="0" cellpadding="0" height="100%">
  <tr>
    <td bgcolor="#D0D0C0" width="150" valign="top" align="left"><img border="0" src="ALP-logo.gif"></td>
    <td width="100%" BACKGROUND="top-header.gif" valign="bottom" align="right" class="bigFont" style="border-bottom: 1 solid rgb(0,0,0); background-repeat: no-repeat; background-position: right;"><i>
        About the ALP engine
    </i></td>
  </tr>
  <tr>
    <td width="150" valign="top" align="center" height="100%" bgcolor="#D0D0C0">
    <!-- #include file="menu-main.htm" -->
    </td>
    <td width="100%" valign="top" height="100%">
    <table border="0" width="100%" cellspacing="0" cellpadding="4">
      <tr>
        <td width="100%" valign="top">
          <P>ALP Engine is a modular system. Its core functionality is implemented in the <b>iewebsrv.dll</b>. This DLL implements
the <b>core</b> features such as: the WEB server-like behavior, the
configuration maintenance, storage for objects with life time longer than single
request (such as Application and Session in ASP) and so on. It also contains the
most popular modules - ASP and CGI processors, the raw file processor.
          </P>
<P>In ALP the processing modules are called <b>Content Generators</b> (CG). The
name comes from their purpose - they generate HTML or other content over the
parameters passed by the core to them. For example the ASP Content Generator
(ALP module) is invoked by the core when the configuration states that the file
pointed by request URL is an ASP page. The core also posts to the CG the query
line parameters, form posts, file uploads and environment and state information
that the module may need.
          </P>
<P>ALP engine works on request-response basis. Each operation performed by it is
formed by a request sent to the engine and response prepared by it and returned
back. We will use further the word request for the entire operation unless
otherwise specified.
          </P>
<P><img border="0" src="ALPScheme2.gif">
          </P>
<P>Each request to the ALP engine has an URL and may include form data or other
data included with it. When the request is processed the ALP engine determines
which configuration settings apply to it. This depends almost fully on the URL
passed to the engine. In ALP the URL has the following sample form:
          </P>
<P><b>alp:</b>//<b>C:</b>/<b>dir1</b>/<b>dir2</b>/<b>file</b>.<b>ext</b>
          </P>
<P>Any WEB developer will ask at this point - this is not enough! And it is so -
an application that behaves as WEB application (no matter that it works on your
desktop without even touching the network functionality) needs to know which is
its <b>WEB site</b>,&nbsp; which is its <b>application root path</b> and
furthermore the ALP engine will need to know how to process the pointed file or
directory.&nbsp;
          </P>
<P>To do so ALP engine uses configuration files spread through the file system.
Where they exist they assign to the directory containing them a specific role or
roles. Thus if there are no such files in the path of the sample URL above ALP
will assume that drive C is a virtual ALP (WEB) site and ALP Application root
directory. Thus any reference to a path like <b>/dir3/dir4</b> in a link,
include directive or Server.MapPath will point to <b>C:\dir3\dir4</b>. But this
is inconvenient when you want to have many applications isolated from each
other.
          </P>
<P>So, if there is an <b>alp.site</b> file (even empty one) in let say <b>C:\dir1\alp.site</b>
ALP will behave otherwise. It will treat <b>C:\dir1</b> and all its
subdirectories as a virtual ALP (WEB) site and the above mappings will point to <b>C:\dir1\dir3\dir4</b>
instead of <b>C:\dir3\dir4</b>.
          </P>
<P>Therefore the existence of alp.site and the other ALP configuration files in
certain points of the file system makes it look like a web of many separate WEB
sites and applications. Each site and ALP application can define its own
settings. ALP engine has default configurations (in the directory containing
iewebsrv.dll) from which it takes the default setting, but the developer can
redefine each setting or add more settings specific for the particular virtual
ALP site or for part of it by putting such files in the corresponding
directories.
          </P>
<P>There is no need to edit or create these files manually. The <a href="shellext.asp"><b>ALP
Settings shell extension</b></a> gives the developer everything needed. You
right click in folder shown in an Windows Explorer window and select ALP
Settings. Then you can create virtual site in that folder, add application and
directory settings.&nbsp;
          </P>
<P><b>What can be changed</b>. The developer can add/change file extensions and
link them to the appropriate Content Generator. For example in a specific
application you may need to process all the .htm files as ASP pages - you just
add this to the application settings in your virtual ALP site and in your
application the .htm files will be treated as ASP pages. As the configuration
applies only for the directory in which it is saved and its subdirectories the
other ALP applications outside will not be harmed. There are many other settings
that can adjust the ALP engine behavior as the application needs it and all they
affect only the directory tree in which they are stored.
          </P>
<P>The effect of this behavior is that the ALP applications when copied, moved
or distributed retain their settings not requiring you to pay additional
attention to them - they are stored in files in the directories of your
application, when you copy/move the application's directory tree you copy/move
the settings as well. This lowers the efforts needed to prepare re-distribution
packages - you know that you can configure your application once and put it in
different distribution packages by just copying it there. Thus you can prepare
redistribution templates and copy the new version of the application in the
place reserved for it in the packages.
          </P>
<P>So, the ALP URL is to be perceived as composed of 4 parts:
          </P>
<P><b>alp://</b><font color="#008000"><b>C:/dir1/</b></font><font color="#000080"><b>dir2/dir3/</b></font><b><font color="#800080">file.ext</font></b>
          </P>
<P><b>alp://</b> - is the ALP protocol name<br>
<font color="#008000"><b>C:/dir1/ </b></font>- is the virtual site URL part<br>
<b><font color="#000080">dir2/dir3/</font></b> - is the path in the site (often
referred as virtual path)<br>
<b><font color="#800080">file.ext</font></b> - is the file referred by the URL
          </P>
<P>Of course the path and the file may be omitted in some URL. ALP supports
default document feature and you can configure in the directory settings which
files will be executed (if found) if no file is specified in the URL explicitly.
The above splitting is defined by the configuration made in the file system so
you need to remember where you have defined virtual site in order to be able to
see the full meaning of an ALP URL. If not sure you can use alpdump:// protocol
to see report about how ALP engine &quot;sees&quot; the passed URL. to do so
just replace alp:// with alpdump://.
          </P>
<P>One of the differences between the WEB servers and ALP is the way it passes
parameters to its modules (Content Generators). While most WEB servers pass the
raw data ALP prepares the data, parses some common parts of it and pass it
ready-for-use to the CG modules. Thus if you have parameters like
?A=something&amp;B=Something on the query line the CG module will receive them
parsed in data holding collections and the module will not need to do its own
parsing or URL decoding. This may be a slight problem for some old applications
(especially CGI-s) that use non-standard parameter syntax, but such applications
are rare and most often out-of-date.&nbsp;
          </P>
<P>The ASP support. ALP processor module (this CG is also referred sometimes as
ScriptGen in the documentation) implements ASP parse and processing features. It
can work with any configured scripting language, the default configuration
already contains settings for VBscript and JScript. The languages can be mixed
in a single page and can use each other. The ASP module supplies the Server,
Request, Response, Session, Application and ScriptingContext objects with the
almost all the functionality known from the classic ASP. Wherever the objects
must supply an URL part or another parameter that in ALP is different from a WEB
server the parameter's value is composed over the URL in such a manner that the
usual operations done with it on a WEB server will produce results with the same
effect in ALP. For example if you need the host name and you want to combine it
with a path - the result will be ok because the host name is a path itself and
the combine path will point in the correct place in the directory structure.
          </P>
<P>The ASP module supports global.asa only without type library import.
&lt;OBJECT RUNAT=SERVER can be used to create objects available to all the ASP
pages in the application through simple and application wide variable name. The
Application_OnStart and Session_OnStart events allow you initialize the
application before any page is shown.
          </P>
<P>If you are new to ASP you can see the ASP module topics in the documentation
where the technology is described and can be learned from scratch.
          </P>
          <P><B>What is the ALP engine for the Windows OS?</B> ALP is implemented as Asynchronous Pluggable Protocol. Such 
          components are also often called custom protocol scheme/namespace handlers. This technique has been introduced with IE 3.0
          and gained real strength with IE 4.0. In fact Windows supports APIs intended to allow the developers to develop
          protocols like http, ftp and so on in abstract manner so that the end-application (a browser for example) can handle them not 
          knowing what they are. They are components invoked to handle certain URL types. Behind the
          scene can be anything - component that fetches resource from the network or generates it locally. You can think
          for ALP and NetProbe component (provided with ALP) as for the both sides of this scheme - ALP is a server that handles the ALP URL:
          beginning with alp:// and NetProbe is a consumer for pluggable protocols - fetches/posts data through any protocol
          including ALP.
          </P>
          <P>Unfortunately this Microsoft Windows API is not documented well.
          Some parts of it are planned in manner
          which looks a bit strange today. However we should not forget that its first implementation was introduced many 
          years ago. We can say that URL Monikers/Pluggable Protocols API is quite good compared to equivalents in other
          OS and environments (For example KDE and GNOME support similar
          features). So we use what we have and even if there are some limitations
          they are not something serious and even in the worst case a work
          around can be found. Thus ALP is one of the pluggable protocols on your machine. By default you will have installed such 
          protocols like - http:, ftp:, file:, gopher:, mk:, res:, about: and so on.
          ALP will add alp: and alpdump: to them.
          </P>
<p><b>Why ASP.NET is not supported by ALP? </b>If you consider the features
offered by the different components of ALP you will notice that there is a
strategy behind them all. ALP develops in direction which is not the direction
assigned to .NET. ALP makes everything possible to make possible an application
to work on all the Windows OS-es in use, even the versions already abandoned by
Microsoft. Most importantly ALP aims at applications that would be able to run
with minimal or even without installation often running from CD-s, flash memory
sometimes running under restrictions that will prevent permanent and even
temporary updates of the system. Another aim which becomes the major goal for
the next versions is to equip ALP with own script language(s) that would be able
to run in source and in compiled form (distributed in non-decompilable form). In
these respects not .NET nor Java meet the goals of ALP. They need installation
that often needs the system to be restarted which may be acceptable for ALP
applications distributed as install packages, but it is absolutely inappropriate
for autorun/run-on-the-fly distributions which ALP supports as well. The
developers need to protect their work from theft, thus looking for solutions
that will not allow any average hacker to de-compile their code and re-use it
without permission. ALP moves in that direction, while the other environments
are going in the other direction - more&nbsp; meta information, preserved
program structure and element names in the compiled assemblies/byte code.</p>
<p>The aims of Active Local Pages technology combined with the components built
for it or included in it are to&nbsp; provide easy to use environment for
stand-alone, easy to deploy applications that can employ wide range of
components internal or external and thus meet the developer preferences. Give
the developer&nbsp; opportunity to choose between ALP supplied highly compatible
components and popular or company specific components so that he/she can achieve
whatever is needed - ultimate compatibility or integration with the other
company software. In future ALP will continue to extend these features by
providing features that will allow the developer to protect the applications
from de-compilation and thus benefit of it not only when the developer manages
to contract with a big customer, but also on the retail market.&nbsp; </p>

        </td>
      </tr>
    </table>
    </td>
  </tr>
  <!-- #include file="footer.htm" -->
</table>


</body>

</html>
