<% @Language=VBScript %>
<!-- #include file="routines.vbs" -->
<%
    Function CheckMime(s)
        If s = "" Then 
            CheckMime = False
        ElseIf Instr(s,"<") > 0 Or Instr(s,">") > 0 Or InStr(s,":") > 0 Or InStr(s,";") > 0 Then
            CheckMime = False
        Else
            CheckMime = True
        End If
    End Function
    
    Set cfg = Server.CreateObject("newObjects.utilctls.ConfigFile")
    Dim app, defaults
    
    If fileDir = "" Then
        ' Read default
        Set dir = cfg.Read(Server.MapPath("defaults/alp.directory"))
        filedir = pathFor & "alp.directory"
        dirDir = pathFor
        cfg.Write fileDir,dir
    Else
        Set dir = cfg.Read(fileDir)
    End If 
    
    ' Check consistency
    If Not IsObject(dir("DIRECTORY")) Then
        dir.Add "DIRECTORY", cfg.CreateSection
    End If
    If Not IsObject(dir("DIRECTORY")("UseExtensions")) Then
        dir("DIRECTORY").Add "UseExtensions", cfg.CreateSection
    End If
    
    Set Mimes = dir("DIRECTORY")("UseExtensions")
    
    Dim extName,extMime
    extName = ""
    extMime = "application/octet-stream"
    

    Dim n, message, str, bShowMessageOnly, Module, ext
    message = ""
    bShowMessageOnly = False
    If Request("EditExt").Count > 0 Then
        If Request("MIMES") <> "." Then
            extMime = CStr(Request("MIMES"))
            extName = Mimes(extMime)
        End If
    ElseIf Request("Remove").Count > 0 Then
        Mimes.Remove Request("MIMES")
        cfg.Write fileDir, dir
    ElseIf Request("Update").Count > 0 Then
        str = CStr(Request("MIME"))
        If CheckMime(str) Then
            Mimes(str) = CStr(Request("EXT"))
            cfg.Write fileDir, dir
        Else
            bShowMessageOnly = True
            message = "Incorrect MIME type specified."
        End If
    ElseIf Request("AddForce").Count > 0 Then
        If fileApp <> "" Then
            Set app = cfg.Read(fileApp)
            If IsObject(app("APPLICATION")) Then
                If IsObject(app("APPLICATION")("InternalExecutionMap")) Then
                    If IsObject(app("APPLICATION")("InternalExecutionMap")("File")) Then
                        Set mmap = OpenCreateSection(cfg,app("APPLICATION")("InternalExecutionMap")("File"),"FileTypes")
                        Set fmap = OpenCreateSection(cfg,app("APPLICATION")("InternalExecutionMap")("File"),"ForceDownload")
                        For I = 1 to fmap.Count
                            If IsObject(mmap(fmap.Key(I))) Then
                                Mimes(CStr(mmap(fmap.Key(I)))) = fmap.Key(I)
                            End If
                        Next
                        cfg.Write fileDir, dir
                    End If
                End If
            End If
        End If         
    Else
        bShowMessageOnly = False
    End IF
    
%>
<html>

<head>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta http-equiv="Content-Language" content="en-us">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<link REL="stylesheet" HREF="styles.css">
<title>ALP Settings</title>
<SCRIPT>
    function PreDef() {
        var p = document.forms["mainfrm"].predef;
        if (p.selectedIndex > 0) {
            document.forms["mainfrm"].MIME.value = p.options[p.selectedIndex].text;
            document.forms["mainfrm"].EXT.value = p.options[p.selectedIndex].value;
        }
    }
</SCRIPT>
</head>

<body topmargin="0" leftmargin="0">

<table border="0" width="100%" cellspacing="0">
  <!-- #include file="head.inc" -->
  <tr>
    <td width="100%">
        <H4>Current directory</H4>
        <BLOCKQUOTE>
            <%= pathFor %><BR>
            <A HREF="dir.asp?Path=<%= pathFor %>">Back to directory settings</A>
        </BLOCKQUOTE>
        <% If bShowMessageOnly Then %>
            <I><B><%= message %></B></I>
        <% Else %>
            <DIV ALIGN="CENTER">
            <FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>" NAME="mainfrm">
                <INPUT TYPE="HIDDEN" NAME="Path" VALUE="<%= pathFor %>">
                MIME to file extension mappings:
                <A HREF="javascript: void window.open('help/default.asp?Page=dir.htm&Mark=MIME')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                <BR>
                <SELECT NAME="MIMES" SIZE="10" CLASS="inpsel">
                    <% For I = 1 To Mimes.Count %>
                        <% If extMime = Mimes.Key(I) Then %>
                            <OPTION SELECTED VALUE="<%= Mimes.Key(I) %>"><%= Mimes.Key(I) %> (<%= Mimes(I) %>)</OPTION>
                        <% Else %>
                            <OPTION VALUE="<%= Mimes.Key(I) %>"><%= Mimes.Key(I) %> (<%= Mimes(I) %>)</OPTION>
                        <% End If %>
                    <% Next %>
                </SELECT><BR>
                <INPUT TYPE="SUBMIT" NAME="EditExt" VALUE="Edit">
                <INPUT TYPE="SUBMIT" NAME="Remove" VALUE="Remove">
                <HR>
                <DIV ALIGN="CENTER">
                    <TABLE>
                        <TR>
                            <TD>File extension
                            <A HREF="javascript: void window.open('help/default.asp?Page=dir.htm&Mark=Ext')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                            </TD>
                            <TD><INPUT CLASS="inp" TYPE="TEXT" NAME="EXT" VALUE="<%= extName %>"></TD>
                        </TR>
                        <TR>
                            <TD>Mime type
                            <A HREF="javascript: void window.open('help/default.asp?Page=dir.htm&Mark=MimeType')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                            </TD>
                            <TD><INPUT CLASS="inp" TYPE="TEXT" NAME="MIME" VALUE="<%= extMime %>">
                            <SELECT NAME="predef" onChange="PreDef()">
                                <OPTION VALUE="">(poplar applications)</OPTION>
                                <OPTION VALUE="doc">application/msword</OPTION>
                                <OPTION VALUE="rtf">text/richtext</OPTION>
                                <OPTION VALUE="mpeg">video/mpeg</OPTION>
                                <OPTION VALUE="pdf">application/pdf</OPTION>
                                <OPTION VALUE="xls">application/excel</OPTION>
                            </SELECT>
                            </TD>
                        </TR>
                    </TABLE>
                    <INPUT TYPE="SUBMIT" NAME="Update" VALUE="Add/Update">
                </DIV>
                <HR COLOR="0" SIZE="1">
                <DIV ALIGN="CENTER">
                    <INPUT TYPE="SUBMIT" NAME="AddForce" VALUE="Add the MIME types with forced download">
                    <A HREF="javascript: void window.open('help/default.asp?Page=dir.htm&Mark=AddForce')" ALT="Help"><IMG SRC="help.gif" BORDER="0"></A>
                </DIV>
            </FORM>
            </DIV>
        <% End If %>
    </td>
  </tr>
</table>

</body>

</html>
