<% @Language=VBScript %>
<%  
    ' The embedded database engine
    Set db = Server.CreateObject("newObjects.sqlite.dbutf8")
    ' Configure the database for automatic type conversions of the returned results
    ' These are the recommended settings
    db.AutoType = True
    db.TypeInfoLevel = 4
    
    ' The string formatting object we will use to create the more complicated queries
    Set su = Server.CreateObject("newObjects.utilctls.StringUtilities")
    
    ' Open our database
    db.Open Server.MapPath("db1.scdb")
    
    ' Perform the requested actions
    If Request("Update").Count > 0 OR Request("AddExp").Count > 0 Then
        db.Execute("BEGIN TRANSACTION")
        db.Execute "DELETE FROM PersonExperience WHERE PersonID=" & Request("PersonID")
        Set rExps = db.Execute("SELECT EXPID FROM Experience")
        For I = 1 To rExps.Count
            If CLng(Request("EXP" & rExps(I)(1))) > 0 Then
                db.Execute su.Sprintf("INSERT INTO PersonExperience (PERSONID,EXPID,YEARS) VALUES " & _
                                      "(%u,%u,%u)", Request("PersonID"), rExps(I)(1), Request("EXP" & rExps(I)(1)))
            End If
        Next
        If Request("AddExp").Count > 0 Then
            Set rTemp = db.Execute(su.Sprintf("INSERT INTO Experience (EXNAME) VALUES (%q)",Request("EXNAME")))
            ' Get the insert id
            newID = rTemp.Info
            db.Execute su.Sprintf("INSERT INTO PersonExperience (PERSONID,EXPID,YEARS) VALUES " & _
                                      "(%u,%u,%u)", Request("PersonID"), newID, Request("EXP"))
        End If
        db.Execute("COMMIT TRANSACTION")
    End If
    
    Set rExp = db.Execute("SELECT Experience.ExpID AS ExpID,Experience.EXName AS EXName,PersonExperience.Years AS Years " & _
                          "FROM Experience LEFT OUTER JOIN PersonExperience ON " & _
                          "Experience.ExpID=PersonExperience.ExpID AND PersonExperience.PersonID=" & _
                          Request("PersonID"))
                          
    ' A helper routine to fill the year of experience select boxes
    Sub YearsOfExperience(sel)
        Dim I,selected
        If IsNull(sel) Then selected = 0 Else selected = CLng(sel)
        %><OPTION VALUE="0">None</OPTION><%
        For I = 1 To 20
            If I = CLng(selected) Then
                %><OPTION SELECTED VALUE="<%= I %>"><%= I %> years</OPTION><%
            Else
                %><OPTION VALUE="<%= I %>"><%= I %> years</OPTION><%
            End If
        Next
    End Sub

%>
<html>

<head>
<meta http-equiv="Content-Language" content="en-us">
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<meta name="GENERATOR" content="Microsoft FrontPage 4.0">
<meta name="ProgId" content="FrontPage.Editor.Document">
<title>Names</title>
</head>

<body>

<%
    Set rPerson = db.Execute("SELECT * FROM Person WHERE PersonId=" & Request("PersonId"))(1)
%>
<h4><%= rPerson("NAME1") & " " & rPerson("NAME2") & " " & rPerson("NAME3") %></h4>
<p>Experience in:</p>

<FORM METHOD="POST" ACTION="<%= Request.ServerVariables("SCRIPT_NAME") %>">
<INPUT TYPE="HIDDEN" NAME="PERSONID" VALUE="<%= Request("PersonID") %>">
<blockquote>
    <% For I = 1 To rExp.Count %>
      <p>
        <select size="1" NAME="EXP<%= rExp(I)("ExpId") %>">
            <% YearsOfExperience rExp(I)("Years") %>
        </select> - <%= rExp(I)("EXName") %></p>
    <% Next %>
  
  <p><input type="submit" value="Update" name="Update"></p>
  
  <p>
    <select size="1" NAME="EXP">
        <% YearsOfExperience 0 %>
    </select> - 
    <input type="text" size="20" NAME="EXNAME">
    <input type="submit" value="Add new field of experience" name="AddExp">
  </p>
</blockquote>
</FORM>

<A HREF="persons.asp">Back to the list</A>

</body>

</html>
